<?php
	$sep = DIRECTORY_SEPARATOR ;
	$thrift_current_dir = dirname( __FILE__ );
	
	#mantisconnectcoreg
	require_once( dirname( $thrift_current_dir ) . $sep . 'soap' . $sep . 'mc_core.php');
	
	#MantisThriftp̊֐Q
	require_once( $thrift_current_dir . $sep . 'mt_api.php');
	
	#thriftlib/php/srcRs[ꏊw
	$GLOBALS['THRIFT_ROOT'] = $thrift_current_dir . $sep . 'src';

	require_once $GLOBALS['THRIFT_ROOT'] . $sep . 'Thrift.php';
	require_once $GLOBALS['THRIFT_ROOT'] . $sep . 'protocol' . $sep . 'TBinaryProtocol.php';
	require_once $GLOBALS['THRIFT_ROOT'] . $sep . 'transport' . $sep . 'TPhpStream.php';
	require_once $GLOBALS['THRIFT_ROOT'] . $sep . 'transport' . $sep . 'TBufferedTransport.php';

	require_once $GLOBALS['THRIFT_ROOT'] . $sep . 'packages' . $sep . 'mantisthrift' . $sep . 'MantisThrift.php';
	
	
	#MantisConnectnusoapɊ܂܂Ăsoap_faultIuWFNg쐬B
	#MantisThriftł́AnusoaprequireĂȂ̂ŁAThriftException
	#p̃NX쐬ĂB
	class soap_fault extends ThriftException {
		function soap_fault($faultcode, $faultactor='', $faultstring=''){
			$this->faultcode = $faultcode;
			$this->faultactor = $faultactor;
			$this->faultstring = $faultstring;
		}
	}
	
	
	#\bh̎
	class MantisThriftHandler implements MantisThriftIf {
		
		#o[W擾
		public function mt_version() {
			return MANTIS_VERSION;
		}
		
		#Xe[^Xꗗ擾
		public function mt_enum_status($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'status');
		}
		#Dxꗗ擾
		public function mt_enum_priorities($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'priority');
		}
		#dvxꗗ擾
		public function mt_enum_severities($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'severity');
		}
		#Čꗗ擾
		public function mt_enum_reproducibilities($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'reproducibility');
		}
		#C@ꗗ擾
		public function mt_enum_projections($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'projection');
		}
		#\Hꗗ擾
		public function mt_enum_etas($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'eta');
		}
		#󋵈ꗗ擾
		public function mt_enum_resolutions($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'resolution');
		}
		#ANZXꗗ擾
		public function mt_enum_access_levels($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'access_levels');
		}
		#vWFNgXe[^Xꗗ擾
		public function mt_enum_project_status($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'project_status');
		}
		#vWFNǧJꗗ擾
		public function mt_enum_project_view_states($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'project_view_state');
		}
		#Č̌J󋵈ꗗ擾
		public function mt_enum_view_states($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'view_state');
		}
		#JX^ڈꗗ擾
		public function mt_enum_custom_field_types($username, $password) {
			return MantisThriftHandler::mt_enum_get( $username, $password, 'custom_field_type');
		}
		#񋓑̂̈ꗗ擾
		public function mt_enum_get($username, $password, $enumeration) {
			return mti_explode_to_objectref(mc_enum_get( $username, $password, $enumeration));
		}
		
		#Č̑݃`FbN
		public function mt_issue_exists($username, $password, $issue_id) {
			$result = mc_issue_exists($username, $password, $issue_id);
			if( get_class( $result ) == 'soap_fault' ) {
				throw $result;
			}
			return $result;
		}
		#Čf[^̎擾
		public function mt_issue_get($username, $password, $issue_id) {
			$issue = mc_issue_get($username, $password, $issue_id);
			if( get_class( $issue ) == 'soap_fault' ) {
				throw $issue;
			}
			
			return mti_parse_array_to_IssueData($issue);
		}
		
		#Č̍ől擾
		public function mt_issue_get_biggest_id($username, $password, $project_id) {
			$biggest_id = mc_issue_get_biggest_id($username, $password, $project_id);
			if( get_class( $biggest_id ) == 'soap_fault' ) {
				throw $biggest_id;
			}
			return $biggest_id;
		}
		#issue_id̎擾
		public function mt_issue_get_id_from_summary($username, $password, $summary) {
			$issue_id = mc_issue_get_id_from_summary($username, $password, $summary);
			if( get_class( $issue_id ) == 'soap_fault' ) {
				throw $issue_id;
			}
			return $issue_id;
		}
		#Č̓o^
		public function mt_issue_add($username, $password, $issue) {
			$issue_id = mc_issue_add($username, $password, mti_parse_IssueData_to_array($issue));
			if( get_class( $issue_id ) == 'soap_fault' ) {
				throw $issue_id;
			}
			return $issue_id;
		}
		#Č̍XV
		public function mt_issue_update($username, $password, $issue_id, $issue) {
			$result= mc_issue_update($username, $password, $issue_id, mti_parse_IssueData_to_array($issue));
			if( get_class( $result) == 'soap_fault' ) {
				throw $result;
			}
			return $result;
		}
		#Č̍폜
		public function mt_issue_delete($username, $password, $issue_id) {
			$result = mc_issue_delete($username, $password, $issue_id);
			if( get_class( $result) == 'soap_fault' ) {
				throw $result;
			}
			return $result;
		}
		
		#Rg̒ǉ
		public function mt_issue_note_add($username, $password, $issue_id, $note) {
			$result = mc_issue_note_add($username, $password, $issue_id, mti_issuenotedata_to_array($note));
			if( get_class( $result) == 'soap_fault' ) {
				throw $result;
			}
			return $result;
		}
		#Rg̍폜
		public function mt_issue_note_delete($username, $password, $note_id) {
			$result = mc_issue_note_delete($username, $password, $note_id);
			if( get_class( $result) == 'soap_fault' ) {
				throw $result;
			}
			return $result;
		}
		
		#֘A̒ǉ
		public function mt_issue_relationship_add($username, $password, $issue_id, $relationship) {
			$result = mc_issue_relationship_add($username, $password, $issue_id, mti_relationshipdata_to_array($relationship));
			if( get_class( $result) == 'soap_fault' ) {
				throw $result;
			}
			return $result;
		}
		
		#֘A̍폜
		public function mt_issue_relationship_delete($username, $password, $issue_id, $relationship_id) {
			$result = mc_issue_relationship_delete($username, $password, $issue_id, $relationship_id);
			if( get_class( $result) == 'soap_fault' ) {
				throw $result;
			}
			return $result;
		}
		
		#Ytt@C̒ǉ
		public function mt_issue_attachment_add($username, $password, $issue_id, $name, $file_type, $content ) {
			$result = mc_issue_attachment_add($username, $password, $issue_id, $name, $file_type, base64_encode($content));
			if( get_class( $result) == 'soap_fault' ) {
				throw $result;
			}
			return $result;
		}
		#Ytt@C̍폜
		public function mt_issue_attachment_delete($username, $password, $issue_attachment_id ) {
			$result = mc_issue_attachment_delete($username, $password, $issue_attachment_id);
			if( get_class( $result) == 'soap_fault' ) {
				throw $result;
			}
			return $result;
		}
		
		#Ytt@C̎擾
		public function mt_issue_attachment_get($username, $password, $issue_attachment_id ) {
			$result = mc_issue_attachment_get($username, $password, $issue_attachment_id);
			if( get_class( $result) == 'soap_fault' ) {
				throw $result;
			}
			return base64_decode($result);
		}
	}

	header('Content-Type', 'application/x-thrift');

	$handler = new MantisThriftHandler();
	$processor = new MantisThriftProcessor($handler);

	$transport = new TBufferedTransport(new TPhpStream(TPhpStream::MODE_R | TPhpStream::MODE_W));
	$protocol = new TBinaryProtocol($transport, true, true);

	$transport->open();
	$processor->process($protocol, $protocol);
	$transport->close();

?>
